 
#include <iostream>
#include <stdlib.h>     /* atoi */
#include "tcpserver.h"

class MyTcpServer : public AlgorithMan::TcpServer
{
    void OnConnect(AlgorithMan::Client* c) override
    {
        std::cout << "Connect " << c->RemoteIP() << std::endl;
    }
    void OnDisconnect(AlgorithMan::Client* c) override
    {
        std::cout << "Disconnect " << c->RemoteIP() << std::endl;
    }
    void OnReceive(AlgorithMan::Client* c, const std::string& message) override
    {
        std::cout << "Received from " << c->RemoteIP() << ": " << message;
    }
};

int main(int argc, char** argv)
{
    int port = 20048;
    if(argc > 1)
        port = atoi(argv[1]);
    MyTcpServer server;
    server.Start(port);
    std::string input;

    try
    {
        while(true)
        {
            std::getline(std::cin, input);
            if(!std::cin.good())
                break;
            if(input == "stop")
                server.Stop();
            else if(input == "start")
                server.Start(port);
            else if(input == "quit")
                break;
            else
                server.Broadcast(input + "\n");
        }
    }
    catch(char const* msg)
    {
        std::cerr << msg << std::endl;
    }
    
    return 0;
}
